(use-modules (gnu)
             (metznet aws)
             (gnu services shepherd)
             (gnu services networking)
             (gnu packages vim)
             (gnu packages version-control)
             (gnu services ssh)
             (gnu packages shells))

(operating-system
  (host-name "guix-ami")
  (timezone "America/Edmonton")
  (locale "en_US.utf8")
  (kernel-arguments (append '("console=ttyS0") %default-kernel-arguments))
  (bootloader (bootloader-configuration
                (bootloader grub-minimal-bootloader)
                (targets '("/dev/nvme1n1"))))
  (swap-devices (list (swap-space (target (file-system-label "guix-swap")))))
  (file-systems (cons (file-system
                        (device (file-system-label "guix-data"))
                        (mount-point "/")
                        (type "ext4")) %base-file-systems))
  (sudoers-file (plain-file "sudoers"
                            (string-join (list "Defaults mail_badpass"
                                               "root ALL=(ALL:ALL) ALL"
                                               "%aws ALL=(ALL:ALL) ALL" "")
                                         "\n")))

  (packages (cons* neovim git %base-packages))

  (services
   (cons* (service dhcp-client-service-type)
          (service aws-service-type)
          (service openssh-service-type
                   (openssh-configuration (port-number 22)
                                          (password-authentication? #f)))
          %base-services)))

