(use-modules (gnu)
             (gnu services certbot)
             (metznet services gitea)
             (metznet system base-system)
             (gnu packages vim)
             (gnu services file-sharing)
             (gnu packages version-control))

(operating-system (inherit %metznet-base-server-system)
                  (host-name "home.metznet.ca")
                  (bootloader (bootloader-configuration
                                (bootloader grub-minimal-bootloader)
                                (targets '("/dev/nvme0n1"))))
                  (swap-devices (list (swap-space
                                        (target (file-system-label
                                                 "home-guix-swap")))))
                  (file-systems (cons (file-system
                                        (device (file-system-label
                                                 "home-guix-data"))
                                        (mount-point "/")
                                        (type "ext4")) %base-file-systems))
                  (packages (cons* git neovim %metznet-base-packages))
                  (services (append (list (service gitea-service-type (gitea-configuration))
                                          (service transmission-daemon-service-type (transmission-daemon-configuration
                                                                                      (download-dir "/var/lib/transmission-daemon/downloads")
                                                                                      (incomplete-dir-enabled? #t)
                                                                                      (incomplete-dir "/var/lib/transmission-daemon/incomplete")
                                                                                      (umask #o022)
                                                                                      (speed-limit-up-enabled? #t)
                                                                                      (speed-limit-up 10000)
                                                                                      (peer-port-random-on-start? #t)
                                                                                      (download-queue-enabled? #f)
                                                                                      (ratio-limit-enabled? #t)
                                                                                      (ratio-limit 4.0)
                                                                                      (lpd-enabled? #t)
                                                                                      (rpc-url "/")
                                                                                      (rpc-whitelist-enabled? #f)
                                                                                      (rpc-host-whitelist-enabled? #f)))
                                      (service certbot-service-type
                                                   (certbot-configuration (email
                                                                           "admin@metznet.ca")
                                                                          (certificates
                                                                           (list
                                                                            (certificate-configuration
                                                                             (domains '
                                                                              ("git.metznet.ca"
                                                                               "home.metznet.ca"
                                                                               "plex.metznet.ca"
                                                                               "p2p.metznet.ca"
                                                                               "files.metznet.ca"))))))))
                                    %metznet-server-services)))

